#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sat Jan 18 11:44:19 2025

@author: user
"""

import numpy as np
import cv2
import matplotlib.pyplot as plt

from skimage.data import brick

image = brick().astype(np.float32)

image = cv2.cvtColor(cv2.imread("Images/1-S.JPG",cv2.IMREAD_UNCHANGED),cv2.COLOR_RGB2GRAY).astype(np.float32)


print("image",image)

# (OPTIONAL) blurr image --> This will change hyperparameters
# image = cv2.blur(image, ksize=(5,5))

# 0-1 normalize
image /= image.max()

k = 0.05
thresh = 0.5

# Sobel kernels
Sx = np.array([
    [1, 0, -1],
    [2, 0, -2],
    [1, 0, -1]])

Sy = Sx.T

# Gaussian Kernel
G = np.array([
    [1, 2, 1],
    [2, 4, 2],
    [1, 2, 1]])/16


def corner_response(image, k=k):
    # compute first derivatives
    dx = cv2.filter2D(image, ddepth=-1, kernel=Sx)
    dy = cv2.filter2D(image, ddepth=-1, kernel=Sy)

    # Gaussian Filter
    A = cv2.filter2D(dx*dx, ddepth=-1, kernel=G)
    B = cv2.filter2D(dy*dy, ddepth=-1, kernel=G)
    C = cv2.filter2D(dx*dy, ddepth=-1, kernel=G)

    cv2.imshow("x",dx)
    cv2.imshow("y",dy)
    cv2.imshow("A",A)
    cv2.imshow("B",B)
    cv2.imshow("C",C)
    
    # compute corner response at all pixels
    return (A*B - (C*C)) - k*(A + B)*(A + B)


def get_harris_corners(image, k=k):

    # compute corner response
    R = corner_response(image, k)

    print("corner-response ",R)
    # find centroids
    ret, labels, stats, centroids = cv2.connectedComponentsWithStats(np.uint8(R > 1e-2))
    # define the criteria to stop and refine the corners
    criteria = (cv2.TERM_CRITERIA_EPS + cv2.TERM_CRITERIA_MAX_ITER, 100, 0.001)
    return cv2.cornerSubPix(image, np.float32(centroids), (9,9), (-1,-1), criteria)



corners = get_harris_corners(image)

# draw corners on output image
image_out = np.dstack((image, image, image))
for (x, y) in corners:
    x = np.round(x).astype(int)
    y = np.round(y).astype(int)
    cv2.circle(image_out, (x, y), radius=3, color=(0, 255, 0), thickness=-1)
    

cv2.imshow("out", image_out)
cv2.waitKey()
cv2.destroyAllWindows()

"""

# compute Harris corner response
R = corner_response(image, k)


_, ax = plt.subplots(1, 2, figsize=(8, 4))
ax[0].imshow(image_out)
ax[0].set_title("Harris Corners");
ax[1].imshow(R < -0.025)
ax[1].set_title("Harris Edges");
"""