#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Jan 16 13:28:23 2025

@author: user
"""

import cv2 as cv
import numpy as np



#
# Gauss-Demo
#
def MaskDetail(img,mask,col,row):
    c,s = mask.shape[0:2]
    px = img[col-int(c/2):col+c-1,row-int(s/2):row+s-1]
    d = mask*px
    s = np.sum(d)
    ss = np.sum(mask)
    if ss==0:
        ss=1
    print("Filtermatrix: ",mask)
    print("Bild:         ",px)
    print("Faltung roh:  ",d)
    print("Summe Faltung:",s)
    print("Faktor:       ",ss)
    print("Neues Pixel:  ",int(s/ss))
    
#
#
#
def TestMask(img,mask):
    pic=[]
    cc,ss = mask.shape[0:2]
    c,s = img.shape[0:2]
    k=np.sum(mask)
    if k==0:
        k=1
    for i in range(cc,c-cc,1):
        rw=[]
        for j in range(ss,s-ss,1):
            rw.append(int(np.sum(mask*img[i-int(cc/2):i+cc-1,j-int(ss/2):j+ss-1])/k))
        pic.append(rw)
    return np.array(pic)

#
# Sobel-Kanten
#
def Sobel(img):
    scale = 1
    delta = 0
    ddepth = cv.CV_16S
    gray = cv.GaussianBlur(img, (3, 3), 0)
    
    grad_x = cv.Sobel(gray, ddepth, 1, 0, ksize=3, scale=scale, delta=delta, borderType=cv.BORDER_DEFAULT)
    print("x", grad_x)
    grad_y = cv.Sobel(gray, ddepth, 0, 1, ksize=3, scale=scale, delta=delta, borderType=cv.BORDER_DEFAULT)
    print("x", grad_x)
    
    abs_grad_x = cv.convertScaleAbs(grad_x)
    abs_grad_y = cv.convertScaleAbs(grad_y)    
    cv.imshow("Abs x",abs_grad_x)    
    cv.imshow("Abs y",abs_grad_y)    
    cv.imshow("and", cv.bitwise_and(abs_grad_x, abs_grad_y))
    
    grad = cv.addWeighted(abs_grad_x, 0.5, abs_grad_y, 0.5, 0)    
    cv.imshow("Result", grad)
    



def Demo(img,y,x):
    s=[]
    g=4
    s.append(np.sum(img[x-g:x-1,y-g:y-1]))
    s.append(np.sum(img[x+1:x+g,y-g:y-1]))
    s.append(np.sum(img[x+1:x+g,y+1:y+g]))
    s.append(np.sum(img[x-g:x-1,y+1:y+g]))
    cv.imshow("1",img[x-g:x,y-g:y])
    cv.imshow("2",img[x:x+g,y-g:y])
    cv.imshow("3",img[x-g:x,y:y+g])
    cv.imshow("4",img[x:x+g,y:y+g])
    cv.imshow("t",img[x-g:x+g,y-g:y+g])
    cv.waitKey()
    return s


def Harris(src):
    
    scale = 1
    delta = 0
    ddepth = cv.CV_16S
    src = cv.GaussianBlur(src, (3, 3), 0)    
    gray = cv.cvtColor(src, cv.COLOR_BGR2GRAY) 
    grad_x = cv.Sobel(gray, ddepth, 1, 0, ksize=3, scale=scale, delta=delta, borderType=cv.BORDER_DEFAULT)
    cv.imshow("x", grad_x)
    grad_y = cv.Sobel(gray, ddepth, 0, 1, ksize=3, scale=scale, delta=delta, borderType=cv.BORDER_DEFAULT)
    abs_grad_x = cv.convertScaleAbs(grad_x)
    abs_grad_y = cv.convertScaleAbs(grad_y)        
    grad = cv.addWeighted(abs_grad_x, 0.5, abs_grad_y, 0.5, 0)   
    
    dst = cv.cornerHarris(grad,2,3,0.04)
    dst = cv.dilate(dst,None)
 
# Threshold for an optimal value, it may vary depending on the image.
    src[dst>0.1*dst.max()]=[0,255,0]
 
    print(dst)
    cv.imshow('dst',src)
    cv.waitKey(0)
    cv.destroyAllWindows()


#
# Demo Scaleninvarianz
#
def Deriv(img,sigma,d,scale):
    c=img.shape[0:1]
    
    d1=cv.GaussianBlur(img, (d,d), sigma)
    d2=cv.GaussianBlur(d1, (d,d), sigma)
    d3=cv.GaussianBlur(d2, (d,d), sigma)
    d4=cv.GaussianBlur(d3, (d,d), sigma)
    
    D1 = img.astype(np.int16) - d1.astype(np.int16)
    D2 = d1.astype(np.int16) - d2.astype(np.int16)
    D3 = d2.astype(np.int16) - d3.astype(np.int16)
    D4 = d3.astype(np.int16) - d4.astype(np.int16)
    
    D1=D1*scale[0]
    D2=D2*scale[1]
    D3=D3*scale[2]
    D4=D4*scale[3]
    cv.imwrite("result/"+str(c)+"-1.jpg", cv.convertScaleAbs(D1))
    cv.imwrite("result/"+str(c)+"-2.jpg", cv.convertScaleAbs(D2))
    cv.imwrite("result/"+str(c)+"-3.jpg", cv.convertScaleAbs(D3))
    cv.imwrite("result/"+str(c)+"-4.jpg", cv.convertScaleAbs(D4))

#
#
#

images = []
images.append("Images/1-L.JPG")              # 0
images.append("Images/1-M.JPG")              # 1
images.append("Images/1-S.JPG")                # 2
images.append("Images/4.png")                # 3
images.append("Images/1-T.JPG")                # 4



#
# Einlesen eines Bildes
#
img_rgb = cv.imread(images[4],cv.IMREAD_UNCHANGED)
img = cv.cvtColor(img_rgb,cv.COLOR_RGB2GRAY)


cv.imshow("original",img)


#
# Demo des Gauss-Prinzips
#
"""
c,l = img.shape[0:2]
mask=np.array([[0.25,0.5,0.25],[0.5,1,0.5],[0.25,0.5,0.25]])
MaskDetail(img,mask,int(c/2),int(l/2))

pic=TestMask(img,mask)
cv.imshow("gauss",pic.astype(np.uint8))

# mit Opencv-Funktion
gray_soft = cv.GaussianBlur(img,(3,3),0)
diff = cv.absdiff(img, gray_soft)

cv.imshow("o",img)
cv.imshow("s",gray_soft)
cv.imshow("d",diff)



# 
# Demo Sobel-Operator
#

sob_mask = np.array([[1,0,-1],[2,0,-2],[1,0,-1]])
MaskDetail(img,sob_mask,500,500)
pic = TestMask(img, sob_mask)
print(pic)
pic = cv.convertScaleAbs(pic)
cv.imshow("son",pic)



#
# OpenCV-Sobeloperator
#
Sobel(img)

"""
"""
#
# Demo Eckenoperator
#

print(Demo(img,335,315))
print(Demo(img,347,333))
print(Demo(img,367,350))
print(Demo(img,397,286))
print(Demo(img,472,319))


#
# Haaris in OpenCV
#

Harris(img_rgb)



#
# Skaleninvarianz
#

Deriv(img,2,5,[10,20,30,40])

height, width = img.shape[:2]
img = cv.resize(img,(int(width/2), int(height/2)))
Deriv(img,2,5,[10,20,30,40])

height, width = img.shape[:2]
img = cv.resize(img,(int(width/2), int(height/2)))
Deriv(img,2,5,[10,20,30,40])


#
# OpenCV
#
gray = img
sift = cv.SIFT_create()
kp = sift.detect(gray,None)

kp, des = sift.detectAndCompute(gray,None)

print("Des ",len(des),len(des[0]),"\n",des)
print("kp ",len(kp),"\n",kp[0:10])
 
img=cv.drawKeypoints(gray,kp,img,flags=cv.DRAW_MATCHES_FLAGS_DRAW_RICH_KEYPOINTS)
 
cv.imwrite('resuilt/sift_keypoints2.jpg',img)

cv.imshow("a", img)
cv.imwrite("result/sift4.jpg",img)


#
# Bilder löschen
#

cv.waitKey()
cv.destroyAllWindows()
"""

img1 = cv.imread('Images/original.jpg',cv.IMREAD_GRAYSCALE)          # queryImage
img2 = cv.imread('Images/part.jpg',cv.IMREAD_GRAYSCALE) # trainImage
 
# Initiate ORB detector
orb = cv.ORB_create()
 
# find the keypoints and descriptors with ORB
kp1, des1 = orb.detectAndCompute(img1,None)
kp2, des2 = orb.detectAndCompute(img2,None)

# create BFMatcher object
bf = cv.BFMatcher(cv.NORM_HAMMING, crossCheck=True)
 
# Match descriptors.
matches = bf.match(des1,des2)
 
# Sort them in the order of their distance.
matches = sorted(matches, key = lambda x:x.distance)
 
# Draw first 10 matches.
img3 = cv.drawMatches(img1,kp1,img2,kp2,matches,None,flags=cv.DrawMatchesFlags_NOT_DRAW_SINGLE_POINTS)
 
cv.imshow("out",img3)
cv.waitKey()
cv.destroyAllWindows()
